// generated by Fast Light User Interface Designer (fluid) version 1.0009

#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "window.h"
#include "placement.h"

#define TRUE  1
#define FALSE 0

Fl_Button *message_box ;
Fl_Button *letter_button [ 256 ] ;
Fl_Multiline_Output *wordlist ;
char       message [ 256 ] ;
char       letter_string [ 256 ] [ 2 ] ;
char       wordlist_text [ 1024 ] ;
int        game_over = FALSE ;

#define AGENDA 1

void setMessage ( char *s )
{
  strcpy ( message, s ) ;
  message_box -> label ( message ) ;
  message_box -> redraw () ;
}

void updateWordlist ()
{
  wordlist_text[0] = '\0' ;
  int line_length = 0;
  int num_words_left = 0;

  for ( int i = 0 ; i < next_word ; i++ )
  {
    if ( words[i][0] != '\0' )
    {
      if ( line_length + strlen ( words[i] ) + 2 > 160/6 )
      {
        strcat ( wordlist_text, "\n" ) ;
        line_length = 0 ;
      }

      line_length += strlen ( words[i] ) + 2 ;
      strcat ( wordlist_text, words[i] ) ;
      strcat ( wordlist_text, ", " ) ;
      num_words_left++ ;
    }
  }

  game_over = ( num_words_left == 0 ) ;

  if ( game_over )
    strcat ( wordlist_text, "-- Game Over --\n-- Well Done --" ) ;

  wordlist->value(wordlist_text);
  wordlist->redraw () ;
}

Fl_Window* make_window()
{
  Fl_Window* w;
  {
#ifdef AGENDA
    Fl_Window* o = new Fl_Window(160, 240, "WordSearch");
#else
    Fl_Window* o = new Fl_Window(320, 480, "WordSearch");
#endif
    w = o;
    o->color(55);

    {
#ifdef AGENDA
      Fl_Button* o = new Fl_Button(0, 220, 35, 20, "Done");
      o->labelsize(10);
#else
      Fl_Button* o = new Fl_Button(0, 440, 70, 40, "Done");
      o->labelsize(20);
#endif
      o->callback((Fl_Callback*)exit_program);
    }

    {
#ifdef AGENDA
      message_box = new Fl_Button(35, 220, 125, 20, message);
      message_box->labelsize(10);
#else
      message_box = new Fl_Button(70, 440, 250, 40, message);
      message_box->labelsize(20);
#endif
    }

    {
#ifdef AGENDA
      wordlist = new Fl_Multiline_Output ( 0, 0, 160, 60, NULL );
      wordlist->textsize(8);
#else
      wordlist = new Fl_Multiline_Output ( 0, 0, 320, 120, NULL );
      wordlist->textsize(16);
#endif
      wordlist_text[0] = '\0' ;
      wordlist->value     ( wordlist_text ) ;
      wordlist->box       ( FL_NO_BOX ) ;
/*
      wordlist->textfont  (  4 ) ;
*/
      wordlist->textcolor ( 55 ) ;
      wordlist->color     ( 42 ) ;
    }

    for ( int i = 0 ; i < 16 ; i++ )
      for ( int j = 0 ; j < 16 ; j++ )
      {
        char *s = letter_string [ i + 16 * j ] ;

        s[0] = '.' ;
        s[1] = '\0' ;

#ifdef AGENDA
        Fl_Button *o = new Fl_Button ( i*10,  60 + j*10, 10, 10, s ) ;
#else
        Fl_Button *o = new Fl_Button ( i*20, 120 + j*20, 20, 20, s ) ;
#endif
        int *data = new int ;
        *data = i+j*16 ;

        o->type            ( 1 ) ;
	o->box             ( FL_FLAT_BOX ) ;
	o->down_box        ( FL_ENGRAVED_BOX ) ;
	o->color           ( 55 ) ;
	o->selection_color ( 48 ) ;
#ifdef AGENDA
	o->labelsize ( 8 ) ;
#else
	o->labelsize ( 16 ) ;
#endif
	o->callback ( (Fl_Callback*)letter, (void*)data ) ;
        letter_button [ *data ] = o ;
      }

    o->end () ;
  }

  return w ;
}



